Robotsystem from Robot Group Leipzig: FeedForwardNN Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# FeedForwardNN Class Reference

`#include <feedforwardnn.h>`

Inheritance diagram for FeedForwardNN:

[legend]
Collaboration diagram for FeedForwardNN:

[legend]
List of all members.

## Detailed Description

abstract class (interface) for feed forward rate based neural networks

Definition at line 11 of file feedforwardnn.h.

## Public Member Functions
| FeedForwardNN ()
virtual | ~FeedForwardNN ()
virtual void | init (unsigned int inputDim, unsigned int outputDim)=0
| initialisation of the network with the given number of input and output units
virtual const matrix::Matrix | process (const matrix::Matrix &input) const =0
| passive processing of the input
virtual const matrix::Matrix | learn (const matrix::Matrix &input, const matrix::Matrix &nom_output, double learnRateFactor=1)=0
virtual void | damp (double damping)=0
| damps the weights and the biases by multiplying (1-damping)
virtual unsigned int | getInputDim () const =0
| returns the number of input neurons
virtual unsigned int | getOutputDim () const =0
| returns the number of output neurons
## Static Public Member Functions
static double | linear (double x)
static double | dlinear (double)
static double | tanh (double x)
static double | dtanh (double x)
static double | sigmoid (double x)
static double | dsigmoid (double x)

## Constructor & Destructor Documentation

FeedForwardNN | ( |  | ) | `[inline]`

| Definition at line 13 of file feedforwardnn.h.

virtual ~FeedForwardNN | ( |  | ) | `[inline, virtual]`

| Definition at line 14 of file feedforwardnn.h.

## Member Function Documentation

virtual void damp | ( | double | damping | ) | `[pure virtual]`

| damps the weights and the biases by multiplying (1-damping) Implemented in MultiLayerFFNN, and OneLayerFFNN.

static double dlinear | ( | double |  | ) | `[inline, static]`

| Definition at line 36 of file feedforwardnn.h.

static double dsigmoid | ( | double | x | ) | `[inline, static]`

| Definition at line 40 of file feedforwardnn.h.

static double dtanh | ( | double | x | ) | `[inline, static]`

| Definition at line 38 of file feedforwardnn.h.

virtual unsigned int getInputDim | ( |  | ) | const`[pure virtual]`

| returns the number of input neurons Implemented in MultiLayerFFNN, and OneLayerFFNN.

virtual unsigned int getOutputDim | ( |  | ) | const`[pure virtual]`

| returns the number of output neurons Implemented in MultiLayerFFNN, and OneLayerFFNN.

virtual void init | ( | unsigned int | inputDim,
|  | unsigned int | outputDim
| ) | `[pure virtual]`

| initialisation of the network with the given number of input and output units Implemented in MultiLayerFFNN, and OneLayerFFNN.

virtual const matrix::Matrix learn | ( | const matrix::Matrix & | input,
|  | const matrix::Matrix & | nom_output,
|  | double | learnRateFactor = `1`
| ) | `[pure virtual]`

| Implemented in MultiLayerFFNN, and OneLayerFFNN.

static double linear | ( | double | x | ) | `[inline, static]`

| Definition at line 35 of file feedforwardnn.h.

virtual const matrix::Matrix process | ( | const matrix::Matrix & | input | ) | const`[pure virtual]`

| passive processing of the input Implemented in MultiLayerFFNN, and OneLayerFFNN.

static double sigmoid | ( | double | x | ) | `[inline, static]`

| Definition at line 39 of file feedforwardnn.h.

static double tanh | ( | double | x | ) | `[inline, static]`

| Definition at line 37 of file feedforwardnn.h.